#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_RedJumpCFG.h"
std::auto_ptr<Fish_RedJumpCFG> Fish_RedJumpCFG::msSingleton(nullptr);

int Fish_RedJumpCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_RedJumpCFGData* Fish_RedJumpCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_RedJumpCFGData>& Fish_RedJumpCFG::GetMapData()
{
	return mMapData;
}

void Fish_RedJumpCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_RedJumpCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_RedJumpCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mRoomOrder = element->IntAttribute("RoomOrder");
		data.mRoomId = element->IntAttribute("RoomId");
		data.mTitle = element->Attribute("Title");
		data.mResources = element->Attribute("Resources");
		data.mDesc = element->Attribute("Desc");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_RedJumpCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_RedJumpCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_RedJumpCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_RedJumpCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_RedJumpCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "RoomOrder", data.mRoomOrder);
		LuaCfgHelper::readInt(L, "RoomId", data.mRoomId);
		LuaCfgHelper::readString(L, "Title", data.mTitle);
		LuaCfgHelper::readString(L, "Resources", data.mResources);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_RedJumpCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_RedJumpCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_RedJumpCFG* Fish_RedJumpCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_RedJumpCFG());
	}
	return msSingleton.get();
}

void Fish_RedJumpCFG::Release()
{
	msSingleton.reset(nullptr);
}
